# fern

Fabulous Extension for Reproducible Notebooks

fern is an extension for the Jupyter Lab Notebook that tracks and
documents your workflow in [amie.ai](https://amie.ai/).

To see a quick demo of it in action checkout the gif below: 

![demo](https://s3-eu-west-1.amazonaws.com/amiemediacdn/fern/Fern-minimal-demo.gif)

## Installation
Install fern with pip and install the jupyter extension:

```
pip install fern-labextension
jupyter labextension install @disraptoer/fern
```

## Usage
To activate fern, add the following lines to the top of your notebook
```
%load_ext fern.fern
%track on "your amie API key"
```

To capture figures you'll also need to run
```
%matplotlib inline
```

If you want to turn the tracker off at any time just run
```
%track off
```

To start tracking agin rerun
```
%track on "your amie API key" 
```
## FAQ

#### Q: How does it work?
We determine the inputs and outputs for each cell by building an
[AST](https://en.wikipedia.org/wiki/Abstract_syntax_tree) of your code. Each new
cell execution creates a new leaf in amie, which is attached in the tree where the
most recent change in the new leaf's inputs occured as an output to a prior
cell.
